//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#include <stdio.h>
#include <inifiles.hpp>
#pragma hdrstop

#define String AnsiString
#include "UnitM.h"
#include "UnitIN.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "Series"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma resource "*.dfm"
TFormM *FormM;


BYTE Mega[0x10000];             //   AT MEGA
								// 0x0000-0x4000 FLASH
								// 0x4000-0x4400 EEPROM
								// 0x4400-0x4C00 SRAM
double TimeChart1=0;            //    1  
double TimeChart2=0;            //    2  
double TimeChart1Start;         //   1 
double TimeChart2Start;         //   2 
const int NumAkkEE=20;          //    EEPROM
const int LenAkkEE=16;          //    EEPROM
const int NumTypEE=16;          //    EEPROM
const int LenTypEE=31;          //    EEPROM
bool fEditTyp=false;            //     
int nEditTyp=-1;                //      
bool fEditAkk=false;            //     
int nEditAkk=-1;                //         
String IntToHex(WORD x);        //       
TChart *TC1, *TC2;              //    
int CW1, CW2, CH1, CH2;         //   
int CL1, CL2, CT1, CT2;         //   
String FName1="";               //      1
String FName2="";               //      2
TDateTime tStart1, tStart2;     //   
BYTE CodeStop1, CodeStop2;		//   1  2 
FILE *tg1, *tg2;                //   
int LB2=-1, LB3=-1;             //   
double E1, E2;                  //  
double told1, told2;            //    
int CurLn=1;                    //        

int COMSpeed;                   //  COM-
String NameTG;                  //      COM-
FILE *TG;						//      COM-
String DirBin;					//   

String Prich[19]={
			"  ",
			" I=0",
			" ",
			" T>50\x04",
			" T>X\x04/",
			".30%  ",
			" Vmin",
			"V12  <11",
			" ",
			"V<Vmin 1 !!!",
			" I>5A",
			" V>25.9",
			" user",
			"V<Vmin 0 !!!",
			". V.",
			" ",
			" Vmax",
			" ",
			"   !!!"
			};


#include "uart.cpp"
#include "util.cpp"
//---------------------------------------------------------------------------
__fastcall TFormM::TFormM(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormM::FormShow(TObject *Sender)
{
LoadIni();
NameTG=FormatDateTime("ddmmyyhhnnss", Now())+".log";
TG=fopen(NameTG.c_str(), "w");
if(CheckBox17->Checked)Button5->Click();
if(CheckBox18->Checked){Button16->Click(); Button7->Click();}
ReShowAll();
}
//---------------------------------------------------------------------------
//     
void __fastcall TFormM::FormClose(TObject *Sender, TCloseAction &Action)
{
SaveIni();
fclose(TG);
if(!CheckBox19->Checked && FileExists(NameTG))DeleteFile(NameTG);
if(fComOpend)CloseCOM();
}
//---------------------------------------------------------------------------
//  COM-
void __fastcall TFormM::Button5Click(TObject *Sender)
{
if(!fComOpend)
  {
  OpenCOM(Edit1->Text.ToInt(), COMSpeed);
  ComboBox10->ItemIndex=0;
  }
else CloseCOM();
ReShowAll();
}
//---------------------------------------------------------------------------
//    
//    
void __fastcall TFormM::Button1Click(TObject *Sender)
{
SB(U_UP);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button2Click(TObject *Sender)
{
SB(U_DOWN);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button4Click(TObject *Sender)
{
SB(U_CANCEL);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button3Click(TObject *Sender)
{
SB(U_OK);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button7Click(TObject *Sender)
{
SB(U_GiveMeScr);
}
//---------------------------------------------------------------------------
//        
void __fastcall TFormM::Timer1Timer(TObject *Sender)
{
String s;
if(!fComOpend)return;                   //     
if(fOnLine)return;                      //        

//    
if(String(S1)!=String(Label1->Caption)){Label1->Caption=String(S1); return;}   //   ,     
if(S2!=Label2->Caption){Label2->Caption=S2; return;}   //   ,     
if(S3!=Label62->Caption){Label62->Caption=S3; return;} //   ,     
if(S4!=Label63->Caption){Label63->Caption=S4; return;} //   ,     
if(fFlash)                              //      
  {
  BYTE x=(fc&0x7f)>>2;                  //    
  BYTE y=fc&3;                          //    
  switch(y)
    {
    case 0: s=Label1->Caption; if(x>s.Length())return; s[x+1]=164; Label1->Caption=s; break;
	case 1: s=Label2->Caption; if(x>s.Length())return; s[x+1]=164; Label2->Caption=s; break;
    case 2: s=Label62->Caption; if(x>s.Length())return; s[x+1]=164; Label62->Caption=s; break;
    case 3: s=Label63->Caption; if(x>s.Length())return; s[x+1]=164; Label63->Caption=s; break;
    }
  }
}
//---------------------------------------------------------------------------
//    32   
void __fastcall TFormM::Memo4DblClick(TObject *Sender)
{
WORD X1, X2;
Memo4->Visible=false;
Memo4->Clear();                        //   
if(RadioButton1->Checked){X1=0x0000; X2=0x4000;} //   FLASH  
if(RadioButton2->Checked){X1=0x4000; X2=0x4400;} //   EEPROM  
if(RadioButton3->Checked){X1=0x4400; X2=0x4C00;} //   SRAM  
if(RadioButton4->Checked){X1=0x0000; X2=0x4C00;} //     
for(int i=X1; i<X2; i+=16)             //   
  {
  String ss=" ";                       //     
  String s=HexToStr(i);                //       
  for(int j=0; j<16; j++)              //      
	{
	s+=" "+IntToHex(Mega[i+j]);        //    
	BYTE c=Mega[i+j];                  //  
	if(c>9)ss+=String(char(c));        //  >9 
	else ss+=".";                      //  <9  
	}
//  AnsiToOem(ss.c_str(), ss.c_str()); //        
  Memo4->Lines->Add(s+ss);             //     
  }
Memo4->Visible=true;
Label36->Caption="CRC16_FLASH="+HexToStr(CrcBuf16(Mega, 0, 0x4000));       //     FLASH
Label37->Caption="CRC16_EEPROM="+HexToStr(CrcBuf16(Mega, 0x4000, 0x400));  //     EEPROM
Label38->Caption="CRC16_SRAM="+HexToStr(CrcBuf16(Mega, 0x4400, 0x800));    //     SRAM
}
//---------------------------------------------------------------------------
//     
void __fastcall TFormM::Button8Click(TObject *Sender)
{
if(Button8->Caption=="")                  //  
  {
  tStart1=Now();
  CodeStop1=0;								   //     "  "
  FName1=FormatDateTime("ddmmyynnss", Now())+".gra"; //    
  tg1=fopen(FName1.c_str(), "w");              //    
  LogAkk(tg1, " 1 ");
  LogAkk(tg1, ": "+ComboBox2->Text);
  LogAkk(tg1, ": "+ComboBox3->Text);
  LogAkk(tg1, ": "+ComboBox7->Text);
  LogAkk(tg1, ": "+Edit2->Text+" .");
  LogAkk(tg1, "***   :");
  TimeChart1=0;                                //    
  Timer2->Interval=Edit2->Text.ToInt()*1000;   //        
  Timer2->Enabled=true;                        //  
  Button8->Caption="";                     //        
  sb_go(1, true);                              //      1 
  }
else                                           //   
  {
  Timer2->Enabled=false;                       //      
  LogAkk(tg2, "###   ");
  LogAkk(tg1, " 1 ");
  LogAkk(tg1, ": "+Edit5->Text);
  LogAkk(tg1, ": "+IntToStr(CodeStop1));
  LogAkk(tg1, ": "+Prich[CodeStop1]);
  double x=Now()-tStart1;
  LogAkk(tg1, ": "+String(floor(x*24*60))+" .");
  Button8->Caption="";                    //      
  sb_go(1, false);                             //      1 
  fclose(tg1);                                 //  
  }
}
//---------------------------------------------------------------------------
//     
void __fastcall TFormM::Button9Click(TObject *Sender)
{
if(Button9->Caption=="")                  //  
  {
  tStart2=Now();
  CodeStop2=0;								   //     "  "
  FName2=FormatDateTime("ddmmyynnss", Now())+".gra"; //    
  tg2=fopen(FName2.c_str(), "w");              //    
  LogAkk(tg2, " 2 ");
  LogAkk(tg2, ": "+ComboBox4->Text);
  LogAkk(tg2, ": "+ComboBox5->Text);
  LogAkk(tg2, ": "+ComboBox8->Text);
  LogAkk(tg2, ": "+Edit3->Text+" .");
  LogAkk(tg2, "***   :");
  TimeChart2=0;                                //    
  Timer3->Interval=Edit3->Text.ToInt()*1000;   //        
  Timer3->Enabled=true;                        //  
  Button9->Caption="";                     //        
  sb_go(2, true);                              //      2 
  }
else                                           //   
  {
  Timer3->Enabled=false;                       //      
  LogAkk(tg2, "###   ");
  LogAkk(tg2, " 2 ");
  LogAkk(tg2, ": "+Edit20->Text);
  LogAkk(tg2, ": "+IntToStr(CodeStop2));
  LogAkk(tg2, ": "+Prich[CodeStop2]);
  double x=Now()-tStart2;
  LogAkk(tg2, ": "+String(floor(x*24*60))+" .");
  Button9->Caption="";                    //      
  sb_go(2, false);                             //      2 
  fclose(tg2);                                 //  
  }
}
//---------------------------------------------------------------------------
//   1   ..
void __fastcall TFormM::Timer2Timer(TObject *Sender)
{
Timer2->Enabled=false;   //           
if(TimeChart1==0)        //     0
  {
  TimeChart1Start=Now();       //   
  Chart1->Series[0]->Clear();  //    1 
  Chart2->Series[0]->Clear();  //    1 
  Chart3->Series[0]->Clear();  //    1 
  Chart3->Series[1]->Clear();  //   
  TimeChart1=(double(Now())-TimeChart1Start)*24*60+1;     //      
  E1=0;
  told1=Now();
  Timer2->Enabled=true;        //   
  return;
  }
E1+=double(Now()-told1)*I1*24.;      //   
told1=Now();
Edit5->Text=FormatFloat("0.000", E1)+" ";
Chart1->Series[0]->AddY(I1, Okr(TimeChart1), clTeeColor); //      
Chart2->Series[0]->AddY(V1, Okr(TimeChart1), clTeeColor); //      
Chart3->Series[0]->AddY(T1, Okr(TimeChart1), clTeeColor); //      
Chart3->Series[1]->AddY(Tc, Okr(TimeChart1), clTeeColor); //      
TimeChart1=(double(Now())-TimeChart1Start)*24*60+1;       //      
if(tg1!=NULL)fprintf(tg1, "%5.2f;%5.2f;%5.2f;%5.2f;%5.2f\n", Okr(TimeChart1), I1, V1, T1, Tc);
Timer2->Enabled=true;          //   
}
//---------------------------------------------------------------------------
//   2   ..
void __fastcall TFormM::Timer3Timer(TObject *Sender)
{
Timer3->Enabled=false;   //           
if(TimeChart2==0)        //     0
  {
  TimeChart2Start=Now();        //   
  Chart4->Series[0]->Clear();   //    2 
  Chart5->Series[0]->Clear();   //    2 
  Chart6->Series[0]->Clear();   //    2 
  Chart6->Series[1]->Clear();   //   
  TimeChart2=(double(Now())-TimeChart2Start)*24*60+1;      //      
  E2=0;
  told2=Now();
  Timer3->Enabled=true;         //   
  return;
  }
E2+=double(Now()-told2)*I2*24.;       //   
told2=Now();
Edit20->Text=FormatFloat("0.000", E2)+" ";
Chart4->Series[0]->AddY(I2, Okr(TimeChart2), clTeeColor);  //      
Chart5->Series[0]->AddY(V2, Okr(TimeChart2), clTeeColor);  //      
Chart6->Series[0]->AddY(T2, Okr(TimeChart2), clTeeColor);  //      
Chart6->Series[1]->AddY(Tc, Okr(TimeChart2), clTeeColor);  //      
TimeChart2=(double(Now())-TimeChart2Start)*24*60+1;        //      
if(tg2!=NULL)fprintf(tg2, "%5.2f;%5.2f;%5.2f;%5.2f;%5.2f\n", Okr(TimeChart2), I2, V2, T2, Tc);
Timer3->Enabled=true;           //   
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Timer4Timer(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)  //     
  {
  Timer4->Enabled=false;                //   
  SB(U_GiveMeADC);                      //     
  Timer4->Enabled=true;                 //   
  }
}
//---------------------------------------------------------------------------
//           
void __fastcall TFormM::RadioButton1Click(TObject *Sender)
{
Memo4DblClick(NULL);
}
//---------------------------------------------------------------------------
//      ,       
void __fastcall TFormM::ListBox2Click(TObject *Sender)
{
if(ListBox2->ItemIndex>=0)ShowTyp();
}
//---------------------------------------------------------------------------
//      ,       
void __fastcall TFormM::ListBox3Click(TObject *Sender)
{
if(ListBox3->ItemIndex>=0)ShowAkk();
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormM::Edit24Exit(TObject *Sender)
{
nEditAkk=ListBox3->ItemIndex;      //   
if(ListBox3->Items->Count>0)Button13->Enabled=fEditAkk=true;   //   
}
//---------------------------------------------------------------------------
//        EEPROM
void __fastcall TFormM::Button13Click(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)return; //      
if(fEditAkk)ShowAkk();     //          
if(!fComOpend){ShowMessage("COM- ."); return;}
int i=MessageBox(Application->Handle, "    EEPROM?", "!!!", MB_YESNO);
if(i==ID_YES)              //    
  {
  Button13->Enabled=false; //      
  int i=ListBox3->ItemIndex;
  OutBuf[0]=U_WriteMemory;            //    
  OutBuf[1]=BYTE(0x4000+i*LenAkkEE);  //     
  OutBuf[2]=BYTE((0x4000+i*LenAkkEE)>>8); //     
  OutBuf[3]=LenAkkEE;                 //   
  for(int j=0; j<LenAkkEE; j++)OutBuf[4+j]=Mega[0x4000+i*LenAkkEE+j]; //       
  OutBuf[LenAkkEE+4]=CrcBuf8(OutBuf, LenAkkEE+4);   //    
  iOutBuf=LenAkkEE+5;                 //    
  SendCommandToCOM();                 // 
  fEditAkk=false;                     //  
  Button16->Click();                  //  EEPROM   
  ShowMessage("Ok");
  return;                             // 
  }
Button13->Enabled=true;               //   ..   
}
//---------------------------------------------------------------------------
//       EEPROM
void __fastcall TFormM::Button12Click(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)return; //      
if(fEditTyp)ShowTyp();     //          
if(!fComOpend){ShowMessage("COM- ."); return;}
int i=MessageBox(Application->Handle, "    EEPROM?", "!!!", MB_YESNO);
if(i==ID_YES)              //    
  {
  Button12->Enabled=false; //      
  WORD a=0x4000+NumAkkEE*LenAkkEE;           //   
  int i=ListBox2->ItemIndex;
  OutBuf[0]=U_WriteMemory;                   //    
  OutBuf[1]=BYTE(a+i*LenTypEE);              //       
  OutBuf[2]=BYTE((a+i*LenTypEE)>>8);         //       
  OutBuf[3]=LenTypEE;                        //    
  for(int j=0; j<LenTypEE; j++)OutBuf[4+j]=Mega[a+i*LenTypEE+j]; //  
  OutBuf[4+LenTypEE]=CrcBuf8(OutBuf, 4+LenTypEE); //   
  iOutBuf=5+LenTypEE;                        //    
  SendCommandToCOM();                        //    
  fEditTyp=false;                            //  
  Button16->Click();                         //  EEPROM   
  ShowMessage("Ok");
  return;                                    // 
  }
Button12->Enabled=true;                      //   ..   
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormM::Edit31Exit(TObject *Sender)
{
nEditTyp=ListBox2->ItemIndex;      //    
if(ListBox2->Items->Count>0)Button12->Enabled=fEditTyp=true;   //   
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button14Click(TObject *Sender)
{
OpenFileToGra(Chart1, Chart2, Chart3);
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button15Click(TObject *Sender)
{
OpenFileToGra(Chart4, Chart5, Chart6);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button16Click(TObject *Sender)
{
if(RadioButton1->Checked)ReadMemoryZU(0x0000, 0x4000, 64);	//  FLASH
if(RadioButton2->Checked)ReadMemoryZU(0x4000, 0x0400, 64);	//  EEPROM
if(RadioButton3->Checked)ReadMemoryZU(0x4400, 0x0800, 64);	//  SRAM
if(RadioButton4->Checked)ReadMemoryZU(0x0000, 0x4C00, 64);	//  
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button19Click(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)return; //      
Button19->Enabled=false;                      //    
Edit29->Text=LoadVarFromZU(BYTE(GetPrm(ComboBox9->Text, 0, ' ').ToInt()));
Button19->Enabled=true;                       //  
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Chart1DblClick(TObject *Sender)
{
TChart *T=(TChart*)Sender;
if(T->Align==alNone)
  {
  if(T==Chart1 ||T==Chart2 ||T==Chart3)
    {
    GroupBox5->Visible=false;
    Chart1->Visible=false;
    Chart2->Visible=false;
    Chart3->Visible=false;
    TC1=T;
    CW1=T->Width;
    CH1=T->Height;
    CL1=T->Left;
    CT1=T->Top;
    T->Visible=true;
    }
  else
    {
    GroupBox6->Visible=false;
    Chart4->Visible=false;
    Chart5->Visible=false;
    Chart6->Visible=false;
	TC2=T;
    CW2=T->Width;
    CH2=T->Height;
    CL2=T->Left;
    CT2=T->Top;
    T->Visible=true;
    }
  T->Align=alClient;
  }
else
  {
  T->Align=alNone;
  if(T==Chart1 ||T==Chart2 ||T==Chart3)
    {
	T->Width=CW1;
    T->Height=CH1;
	T->Left=CL1;
    T->Top=CT1;
    GroupBox5->Visible=true;
    Chart1->Visible=true;
    Chart2->Visible=true;
    Chart3->Visible=true;
    }
  else
    {
    T->Width=CW2;
    T->Height=CH2;
    T->Left=CL2;
    T->Top=CT2;
    GroupBox6->Visible=true;
    Chart4->Visible=true;
    Chart5->Visible=true;
    Chart6->Visible=true;
    }
  }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//           
void __fastcall TFormM::Button24Click(TObject *Sender)
{
int ii=0;
char tmp[2002];
FILE *sr;                                            //   
sr=fopen(String(ComboBox10->Text+".nas").c_str(), "r"); //  
if(sr!=NULL)                                         //  
  {
  Chart7->Series[0]->Clear();
  Chart7->Series[1]->Clear();
  while(UFGetL(sr, tmp))
	{
	String T=tmp;
	if(T.IsEmpty())break;
	ii++;
	StringGrid1->RowCount=ii+1;
	StringGrid1->ColCount=5;
	double a1=atof(GetPrm(T, 0, ';').c_str());
	double a2=atof(GetPrm(T, 1, ';').c_str());
	double a3=atof(GetPrm(T, 2, ';').c_str());
	StringGrid1->Cells[1][ii]=a1;
	StringGrid1->Cells[2][ii]=a2;
	StringGrid1->Cells[3][ii]=a3;
	StringGrid1->Cells[4][ii]=0;
	Chart7->Series[0]->AddXY(a2, a3, "", clTeeColor); //      
	}
  fclose(sr);
  Edit21->Text=ii;
  InitGrid();
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormM::ComboBox10Change(TObject *Sender)
{
InitGrid();
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button27Click(TObject *Sender)
{
ShowMessage(String(
"      1  :\n\n\n")+
"1.     2   12 50.\n      \"  \".   , \n     (I~=1700  V~=1700  >0) \n      (I~=30000  V~=30000).\n           .\n\n"+
"2.      .\n\n"+
"3.  \"  \".       .\n\n"+
"4.     R (0.05)  V12 (  ,\n      ) -     \"  \"\n\n"+
"5.         \"  \".\n             (I  V).\n\n"+
"6.    \" \".\n\n"+
"7.    (a, b, c)  .\n\n"+
"8.    2 ( 4   ).\n\n"+
"9.  .   \"  \".   ,\n        ,    ."
);
}
//---------------------------------------------------------------------------
//      
void __fastcall TFormM::Button20Click(TObject *Sender)
{
int ii=Edit21->Text.ToInt();
char tmp[2002];
FILE *tg;                                            //   
tg=fopen(String(ComboBox10->Text+".nas").c_str(), "w"); //  
if(tg!=NULL)                                         //  
  {
  for(int i=0; i<ii; i++)
	{
	int i1, i2;
	float i3;
	try{i1=StringGrid1->Cells[1][i+1].ToInt();}catch(...){i1=0;}
	try{i2=StringGrid1->Cells[2][i+1].ToInt();}catch(...){i2=0;}
	try{i3=StringGrid1->Cells[3][i+1].ToDouble();}catch(...){i3=0;}
	fprintf(tg, "%d;%d;%f\n", i1, i2, i3);
	}
  fclose(tg);
  }
}
//---------------------------------------------------------------------------
// 
void __fastcall TFormM::Button21Click(TObject *Sender)
{
float k[3][4];
float x[1000];
float y[1000];
float a, b, c;
int ii=Edit21->Text.ToInt();
int i1=0, i2=ii/2-1, i3=ii-1;
if(i2==i1 || i2==i3){ShowMessage(" !!!"); return;}

for(int i=0; i<3; i++)
for(int j=0; j<4; j++)
  k[i][j]=0;
k[0][0]=ii;
for(int i=0; i<ii; i++)
  {
  x[i]=StringGrid1->Cells[2][i+1].ToInt();
  y[i]=StringGrid1->Cells[3][i+1].ToDouble();
  k[0][1]+=x[i];
  k[0][2]+=x[i]*x[i];
  k[0][3]+=y[i];
  k[1][2]+=x[i]*x[i]*x[i];
  k[1][3]+=y[i]*x[i];
  k[2][2]+=x[i]*x[i]*x[i]*x[i];
  k[2][3]+=y[i]*x[i]*x[i];
  }
k[1][0]=k[0][1];
k[1][1]=k[0][2];
k[2][0]=k[0][2];
k[2][1]=k[1][2];

a=((k[0][3]/k[0][0]-k[2][3]/k[2][0])/(k[0][1]/k[0][0]-k[2][1]/k[2][0])-(k[0][3]/k[0][0]-k[1][3]/k[1][0])/(k[0][1]/k[0][0]-k[1][1]/k[1][0]))/
  ((k[0][2]/k[0][0]-k[2][2]/k[2][0])/(k[0][1]/k[0][0]-k[2][1]/k[2][0])-(k[0][2]/k[0][0]-k[1][2]/k[1][0])/(k[0][1]/k[0][0]-k[1][1]/k[1][0]));
b=((k[0][3]/k[0][0]-k[1][3]/k[1][0])-a*(k[0][2]/k[0][0]-k[1][2]/k[1][0]))/(k[0][1]/k[0][0]-k[1][1]/k[1][0]);
c=(k[0][3]-b*k[0][1]-a*k[0][2])/k[0][0];

Edit22->Text=a;
Edit28->Text=b;
Edit30->Text=c;
Button28->Click();
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormM::Button28Click(TObject *Sender)
{
int x[1000];
float y[1000];
float a, b, c, f;
int ii=Edit21->Text.ToInt();
for(int i=0; i<ii; i++)
  {
  x[i]=StringGrid1->Cells[2][i+1].ToInt();
  y[i]=StringGrid1->Cells[3][i+1].ToDouble();
  }
a=Edit22->Text.ToDouble();
b=Edit28->Text.ToDouble();
c=Edit30->Text.ToDouble();
Chart7->Series[0]->Clear();
Chart7->Series[1]->Clear();
for(int i=0; i<ii; i++)
  {
  f=x[i]*(a*x[i]+b)+c;
//  if(FormM->ComboBox10->Text.Pos("")>0)f=x[i]*(a*x[i]+b)+c;
//  else f=b*x[i]+c;
  StringGrid1->Cells[4][i+1]=FormatFloat("0.000", f);
  Chart7->Series[0]->AddXY(x[i], y[i], "", clTeeColor); //      
  Chart7->Series[1]->AddXY(x[i], f, "", clTeeColor); 	//      
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Edit22Exit(TObject *Sender)
{
Button28->Click();
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button25Click(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)return; //      
  FormIN->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TFormM::StringGrid1SelectCell(TObject *Sender, int ACol, int ARow,
		  bool &CanSelect)
{
CurLn=ARow;
FormIN->Caption=String("  ")+IntToStr(CurLn);
FormIN->Edit1->Text=StringGrid1->Cells[1][CurLn];
FormIN->Edit2->Text="0.000";
FormIN->Edit3->Text="0";
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Edit33Exit(TObject *Sender)
{
Edit33->Text=FormatFloat("0.000", ToDouble(Edit33->Text));
}
//---------------------------------------------------------------------------
//  kV12=V12/Adc[6]    EEPROM 
//   
void __fastcall TFormM::Button26Click(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)return; //      
Button26->Enabled=false;                      //  

//  R, R,  V12
if(ComboBox10->Text.Pos("1")>0)
  SendFloatToZu(ToDouble(Edit35->Text), 906);
else
  SendFloatToZu(ToDouble(Edit35->Text), 910);
float kV12=ToDouble(Edit33->Text)/ToDouble(LoadVarFromZU(23));
SendFloatToZu(kV12, 902);


if(ComboBox10->ItemIndex==0) //    
  {
  SendFloatToZu(ToDouble(Edit30->Text), 830);
  SendFloatToZu(ToDouble(Edit28->Text), 834);
  SendFloatToZu(ToDouble(Edit22->Text), 838);
  }
if(ComboBox10->ItemIndex==1) //    
  {
  SendFloatToZu(ToDouble(Edit30->Text), 854);
  SendFloatToZu(ToDouble(Edit28->Text), 858);
  SendFloatToZu(ToDouble(Edit22->Text), 862);
  }
if(ComboBox10->ItemIndex==2) //    
  {
  SendFloatToZu(ToDouble(Edit30->Text), 878);
  SendFloatToZu(ToDouble(Edit28->Text), 882);
  SendFloatToZu(ToDouble(Edit22->Text), 886);
  }
if(ComboBox10->ItemIndex==3) //    
  {
  SendFloatToZu(ToDouble(Edit30->Text), 842);
  SendFloatToZu(ToDouble(Edit28->Text), 846);
  SendFloatToZu(ToDouble(Edit22->Text), 850);
  }
if(ComboBox10->ItemIndex==4) //    
  {
  SendFloatToZu(ToDouble(Edit30->Text), 866);
  SendFloatToZu(ToDouble(Edit28->Text), 870);
  SendFloatToZu(ToDouble(Edit22->Text), 874);
  }
if(ComboBox10->ItemIndex==5) //    
  {
  SendFloatToZu(ToDouble(Edit30->Text), 890);
  SendFloatToZu(ToDouble(Edit28->Text), 894);
  SendFloatToZu(ToDouble(Edit22->Text), 898);
  }
Button26->Enabled=true;                       //  
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button23Click(TObject *Sender)
{
if(Timer2->Enabled || Timer3->Enabled)return; //      
Button23->Enabled=false;                      //  

//  R,  V12
if(ComboBox10->Text.Pos("1")>0)
  Edit35->Text=FormatFloat("0.000", ToDouble(LoadFloatFromZU(906)));
else
  Edit35->Text=FormatFloat("0.000", ToDouble(LoadFloatFromZU(910)));
Edit33->Text=FormatFloat("0.000", ToDouble(LoadVarFromZU(3)));

if(ComboBox10->ItemIndex==0) //    
  {
  Edit30->Text=LoadFloatFromZU(830);
  Edit28->Text=LoadFloatFromZU(834);
  Edit22->Text=LoadFloatFromZU(838);
  }
if(ComboBox10->ItemIndex==1) //    
  {
  Edit30->Text=LoadFloatFromZU(854);
  Edit28->Text=LoadFloatFromZU(858);
  Edit22->Text=LoadFloatFromZU(862);
  }
if(ComboBox10->ItemIndex==2) //    
  {
  Edit30->Text=LoadFloatFromZU(878);
  Edit28->Text=LoadFloatFromZU(882);
  Edit22->Text=LoadFloatFromZU(886);
  }
if(ComboBox10->ItemIndex==3) //    
  {
  Edit30->Text=LoadFloatFromZU(842);
  Edit28->Text=LoadFloatFromZU(846);
  Edit22->Text=LoadFloatFromZU(850);
  }
if(ComboBox10->ItemIndex==4) //    
  {
  Edit30->Text=LoadFloatFromZU(866);
  Edit28->Text=LoadFloatFromZU(870);
  Edit22->Text=LoadFloatFromZU(874);
  }
if(ComboBox10->ItemIndex==5) //    
  {
  Edit30->Text=LoadFloatFromZU(890);
  Edit28->Text=LoadFloatFromZU(894);
  Edit22->Text=LoadFloatFromZU(898);
  }
Button23->Enabled=true;                       //  
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Edit21Change(TObject *Sender)
{
int ii, max, min;
try
  {
  ii=Edit21->Text.ToInt();
  min=Edit37->Text.ToInt();
  max=Edit39->Text.ToInt();
  }
catch(...)
  {
  return;
  }
InitGrid();
for(int i=0; i<ii; i++)
  {
  StringGrid1->Cells[1][i+1]=min+i*(max-min)/(ii-1);
  StringGrid1->Cells[2][i+1]=0;
  StringGrid1->Cells[3][i+1]=0;
  StringGrid1->Cells[4][i+1]=0;
  }
}
//---------------------------------------------------------------------------
//    EEPROM
void __fastcall TFormM::Button31Click(TObject *Sender)
{
ReadMemoryZU(0x4000, NumAkkEE*LenAkkEE, 16);
}
//---------------------------------------------------------------------------
//    EEPROM
void __fastcall TFormM::Button32Click(TObject *Sender)
{
ReadMemoryZU(0x4000+NumAkkEE*LenAkkEE, NumTypEE*LenTypEE, 16);
}
//---------------------------------------------------------------------------
//  FLASH EEPROM SRAM  
void __fastcall TFormM::Button10Click(TObject *Sender)
{
MegaToFile("fes.bin", 0, 0x4C00);
}
//---------------------------------------------------------------------------
//   FLASH EEPROM SRAM     
void __fastcall TFormM::Button11Click(TObject *Sender)
{
FileToMega("fes.bin", 0, 0x4C00);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button6Click(TObject *Sender)
{
FileToMega("acc.bin", 0x4000, NumAkkEE*LenAkkEE);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button22Click(TObject *Sender)
{
MegaToFile("acc.bin", 0x4000, NumAkkEE*LenAkkEE);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button29Click(TObject *Sender)
{
FileToMega("typ.bin", 0x4000+NumAkkEE*LenAkkEE, NumTypEE*LenTypEE);
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormM::Button30Click(TObject *Sender)
{
MegaToFile("typ.bin", 0x4000+NumAkkEE*LenAkkEE, NumTypEE*LenTypEE);
}
//---------------------------------------------------------------------------

